︠42b0ec7d-411b-48af-ba67-6c7389cb49aai︠
%html
<h1><center><font face='Arial Black'> RSA Encryption Based on Elliptic Curves</font></center></h1>
︡56701cbd-455c-47f2-996c-c26fe168cf02︡{"done":true,"html":"<h1><center><font face='Arial Black'> RSA Encryption Based on Elliptic Curves</font></center></h1>"}
︠17a8d4a4-5b2f-4a38-a1a4-d56df4318da4s︠
import numpy
import itertools
def ASCIIPad(Message,p):
    K = (map(ord,reversed(Message)));
    #print(K);
    le= len(K);
    #print(le);
    x = [100+K[i] for i in range(le)];
    x = ZZ(x,1000);
    return([x]);
def ASCIIDepad(Number):
    N = "";
    Number = ZZ(Number[0])
    n = Number.ndigits() % 3;
    if (n > 0):
        print("This is not a padded ASCII string\n");
    else:
        L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
        for i in range(Number.ndigits()/3):
            N = chr(L[i]) + N;
    return(N);
def ECRAdd(Point1,Point2,Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    #print Point2
    if Point1!=[]:
        x1 = Point1[0]
        y1 = Point1[1]
    if Point2!=[]:
        x2 = Point2[0]
        y2 = Point2[1]
    if ZZ(mod(4*a^3 + 27*b^2, p)) == 0:
        print "This is not an ellitpic curve"
    elif Point1!=[] and ZZ(mod(y1^2, p)) != ZZ(mod(x1^3 + a*x1 + b,p)):
        print "Point 1 is not on the elliptic curve."
    elif Point2!=[] and ZZ(mod(y2^2, p)) != ZZ(mod(x2^3 + a*x2 + b,p)):
        print "Point 2 is not on the elliptic curve."
    else:
        if Point1==[]:
            R=Point2
        elif Point2=={}:
            R=Point1
        else:
            if x1==x2 and 0==ZZ(mod(y1+y2,p)):
                R=[]
            elif x1==x2 and y1==y2:
                R=ECRDouble(Point1,Group)
                if R==True:
                    return(True)
            else:
                g=gcd(x1-x2,p)
                if (g>1):
                    print "factor is {0}".format(g)
                    return(True)
                s=ZZ(mod((y1-y2)/(x1-x2),p))
                x=ZZ(mod(s^2-(x1+x2),p))
                y=ZZ(mod(s*(x1-x)-y1,p))
                R=[x,y]
    return R

︡e77ef29d-b97f-4bb1-9b85-7886e47839e2︡{"done":true}
︠90ac010a-30cd-4b87-9627-909d505578e7s︠
def ECRDouble(Point,Group):
    a = Group[0]
    b = Group[1]
    p = Group[2]
    if Point!=[]:
        x1 = Point[0]
        y1 = Point[1]
        if ZZ(mod(4*a^3 + 27*b^2, p)) == 0:
            print "This is not an ellptic curve"
        elif Point!= [] and ZZ(mod(y1^2,p))!= ZZ(mod(x1^3+a*x1+b,p)):
            print "point to double not on elliptic curve"
        elif y1==0:
            R=[]
        else:
            g = gcd(y1,p)
            if g>1:
                print "Factor is {0}".format(g)
                return True
            s = ZZ(mod((3*x1^2+a)/(2*y1),p))
            x = ZZ(mod(s^2-(x1+x1),p))
            y = ZZ(mod(s*(x1-x)-y1,p))
            R = [x,y]
    else:
        R=[]
    return R



︡cd63b08c-78cc-49b3-9061-36afee4a5231︡{"done":true}
︠942b0a3b-2d91-4949-9b44-be6a260d977bs︠
def ECRTimes(Point,scalar,Group):
    ECIDENTITY = []
    if Point==ECIDENTITY or scalar ==0:
        return ECIDENTITY
    else:
        m = scalar
        pt = Point
        x = ECIDENTITY
        #for j in xrange(1,scalar+1):
        j=1
        while j<(scalar +1):
            if m%2==0:
                m = m/2
            else:
                m=(m-1)/2

                x=ECRAdd(x,pt,Group)
                if x==True:
                    return true
            if m==0:
                return x
            pt = ECRDouble(pt,Group)
            if pt==True:
                return true
            j+=1
︡83bc9770-2155-4a44-9588-4a413934808e︡{"done":true}
︠70727cb4-a6e0-4d08-9989-d821f91e4d87︠
def ECRInverse (Point, Group):
    if Point == []:
        return(Point)
    else:
        p = Group[2]
        x = Point[0]
        y = Point[1]
        return([x,(p - y) % p])
︡06b03a87-69b2-4305-a53c-e428eb03369b︡{"done":true}
︠b3d2656b-b82a-47f7-90e6-ef41ad976572si︠
%latex

\flushleft {\bf Example.} Encrypt the message "Information Security" using the public EC RSA key \\
$n=6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791$
$s=10008345747001$
︡bc2b85d2-de7e-4591-bd2a-de36066ab04f︡{"file":{"filename":"/tmp/tmpDndHyv.png","show":true,"text":null,"uuid":"a6c451df-f3f1-4d1b-9e41-250c614740df"},"once":false}︡{"stdout":"\n"}︡{"done":true}
︠abb2d987-b1a5-405b-b3d6-8423b4675a29s︠
n=6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791
s=10008345747001
t= 4117749622628666100756441055185740317505736625202292131017935879300104542402810720953433
print'Private Key:' 
print 't=', t
print'Public Key:'
print 'n=', n
print 's=', s

︡81cde3a1-65e1-480a-bd37-6f95b2cf08e6︡{"stdout":"Private Key:\n"}︡{"stdout":"t= 4117749622628666100756441055185740317505736625202292131017935879300104542402810720953433\n"}︡{"stdout":"Public Key:\n"}︡{"stdout":"n= 6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791\n"}︡{"stdout":"s= 10008345747001\n"}︡{"done":true}
︠485daec4-77ab-4032-8f5b-8fe80620f98c︠
M="Information Security"
m=ASCIIPad(M,n)
print'The padded ASCII version of the plaintext is:', m
︡8fda33c9-20c7-4c16-a540-e219a3b39f03︡{"stdout":"The padded ASCII version of the plaintext is: [173210202211214209197216205211210132183201199217214205216221]\n"}︡{"done":true}
︠87092631-bb7e-4b87-a4fb-59e9c45d367cs︠

b=(1-m[0]^3) %n
E=[0,b,n]
print'The elliptic curve group is:', E
︡3c515875-8f2f-4669-b99c-c01255ecd62e︡{"stdout":"The elliptic curve group is: [0, 3020530985299184291599609240714612842029478907414102977434017401106896368717353991604026, 6917257498733996147938371874633328816556752630891230167602750050663225392713827472369791]\n"}︡{"done":true}
︠81350517-e571-4f85-b97d-39d7e74792d0s︠
pt=[m[0],1]
c=ECRTimes(pt,s,E)
print'The ciphertext is:', c
︡ce46b4af-b50b-44af-924a-180d7a218dcd︡{"stdout":"The ciphertext is: [1835449135407271122180175106020375488710177408875137798012322720564309179236753357104986, 6746005215820619885607422385239986394759560144857805498142475098742794305531869234326693]\n"}︡{"done":true}
︠5bdde763-2053-4720-a980-7fd1d0d7f718si︠
%latex
\flushleft {\bf Example.} Decrypt the ciphertext from the previous example using the private key $t= 4117749622628666100756441055185740317505736625202292131017935879300104542402810720953433$.
︡3a339afe-fa83-4d4c-a5ae-c4f95f7d31a5︡{"file":{"filename":"/tmp/tmp0lzCEn.png","show":true,"text":null,"uuid":"932f8beb-658a-4176-837e-4d055c3efc7f"},"once":false}︡{"stdout":"\n"}︡{"done":true}
︠c5c3188c-d2aa-4f08-ba30-8e58e41f3fb1s︠
B=(c[1]^2-c[0]^3) %n
ED=[0,B,n]
ptd=ECRTimes(c,t,ED)
ptd
ASCIIDepad([ptd[0]])
︡3deb2229-c819-4a7b-af19-f318888baac7︡{"stdout":"[173210202211214209197216205211210132183201199217214205216221, 1]\n"}︡{"stdout":"'Information Security'\n"}︡{"done":true}









